package ru.dbotthepony.mc.otm.data.condition

import net.minecraft.world.level.storage.loot.LootContext
import net.minecraft.world.level.storage.loot.parameters.LootContextParams
import net.minecraft.world.level.storage.loot.predicates.InvertedLootItemCondition
import net.minecraft.world.level.storage.loot.predicates.LootItemCondition
import net.minecraft.world.level.storage.loot.predicates.LootItemConditionType
import ru.dbotthepony.mc.otm.data.get
import ru.dbotthepony.mc.otm.registry.MLootItemConditions

object KilledByRealPlayer : LootItemCondition, LootItemCondition.Builder {
	override fun test(t: LootContext): Boolean {
		return t.hasParam(LootContextParams.LAST_DAMAGE_PLAYER) //&& t[LootContextParams.LAST_DAMAGE_PLAYER] !is FakePlayer
	}

	override fun getType(): LootItemConditionType {
		return MLootItemConditions.KILLED_BY_REAL_PLAYER
	}

	override fun build(): LootItemCondition {
		return this
	}

	val INVERTED: LootItemCondition = InvertedLootItemCondition.invert(this).build()
}
